import OptimisticValue, { PendingOptimisticValue, FulfilledOptimisticValue, RejectedOptimisticValue } from './OptimisticValue';
export { OptimisticValue, PendingOptimisticValue, FulfilledOptimisticValue, RejectedOptimisticValue, };
export default class OptimisticValueStore {
    private readonly _key;
    private _nextID;
    private readonly _fulfilled;
    private readonly _rejected;
    constructor(key?: string, nextID?: number);
    isOptimisticValue(value: any): value is OptimisticValue;
    createValue(): PendingOptimisticValue;
    resolve(optimisticValue: PendingOptimisticValue, value: string): void;
    reject(optimisticValue: PendingOptimisticValue, err: Error): void;
    isFulfilled(value: OptimisticValue): value is FulfilledOptimisticValue;
    isRejected(value: OptimisticValue): value is RejectedOptimisticValue;
    getValue(value: FulfilledOptimisticValue): string;
    getError(value: RejectedOptimisticValue): Error;
    normalizeValue(value: any): {
        value: any;
        pendingKeys: PendingOptimisticValue[];
        rejection: null | Error;
    };
}
