"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var SessionID_1 = require("../types/SessionID");
var crypto_1 = require("crypto");
function randomBytesAsync(n) {
    return new Promise(function (resolve, reject) {
        crypto_1.randomBytes(n, function (err, buf) {
            if (err)
                reject(err);
            else
                resolve(buf);
        });
    });
}
function getSessionID(sessionStore) {
    return sessionStore && sessionStore.getSessionID
        ? Promise.resolve(null).then(function () { return sessionStore.getSessionID(); })
        : randomBytesAsync(12).then(function (sessionID) {
            return SessionID_1.default.unsafeCast(sessionID.toString('base64'));
        });
}
exports.default = getSessionID;
//# sourceMappingURL=get-session-id.js.map