"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function notEqual(oldValue, newValue) {
    if (oldValue === newValue)
        return false;
    return (Object.keys(oldValue).some(function (key) {
        var oldProp = oldValue[key];
        var newProp = newValue[key];
        if (oldProp === newProp)
            return false;
        if (typeof oldProp === 'object' &&
            oldProp &&
            typeof newProp === 'object' &&
            newProp) {
            if (Array.isArray(oldProp) && Array.isArray(newProp)) {
                return (oldProp.length !== newProp.length ||
                    oldProp.some(function (valOld, i) {
                        var valNew = newProp[i];
                        if (valOld === valNew)
                            return false;
                        if (typeof valOld === 'object' &&
                            typeof valNew === 'object' &&
                            valOld &&
                            valNew) {
                            return notEqual(valOld, valNew);
                        }
                        return true;
                    }));
            }
            if (!Array.isArray(oldProp)) {
                return notEqual(oldProp, newProp);
            }
        }
        return true;
    }) || Object.keys(newValue).some(function (key) { return !(key in oldValue); }));
}
exports.default = notEqual;
//# sourceMappingURL=not-equal.js.map